#include "DxLib.h"
#include "Player.h"
#include "CharMove.h"

CPlayer::CPlayer(float x, float y)
	:CMover(x, y, -16, -16, 16, 16) {
	POINT pt[] =
	{
		{ (LONG)L,	(LONG)T },//
		{ 0,			(LONG)T },//^
		{ (LONG)R,	(LONG)T },//E

		{ (LONG)L,	0 },//^
		{ (LONG)R,	0 },//E^

		{ (LONG)L,	(LONG)B },//
		{ 0,			(LONG)B },//^
		{ (LONG)R,	(LONG)B },//E
	};
	ColObj = new CCharMove(pt, 0, 0, 0, 0, 0);
}

void CPlayer::Init(void) {
	//摜ǂݍށB
	X = 160.0F, Y = 240.0F;
	Graph = LoadGraph("eXgp.png");
	Dir = FALSE;
	Dash = FALSE;
}

void CPlayer::Update(void) {
	{
		int i;
		i = GetJoypadInputState(DX_INPUT_KEY_PAD1);
		EdgeInput = i & ~Input;
		Input = i;
	}
	VX = 0.0F;
	//L̓B
	if ((Input&PAD_INPUT_RIGHT)) {
		Dir = FALSE;
		VX = 2.5F;
	}
	if ((Input&PAD_INPUT_LEFT)) {
		Dir = TRUE;
		VX = -2.5F;
	}
	X += VX;
}

void CPlayer::Draw(void) {
	//`B
	DrawRotaGraph((int)X + 8, (int)Y - 8, 1.0, 0.0, Graph, TRUE, Dir);
}

void CPlayer::Fin(void) {
	//摜폜B
	DeleteGraph(Graph);
}