//-----------------------------------------------------------------------------
// Platinumo͂*.fmft@CǂݏoNX
// ǐdɏĂ̂Ōdꍇ͏ĎgpĂB
//-----------------------------------------------------------------------------
#ifndef __CLASS_FMFMAP_H__
#define __CLASS_FMFMAP_H__
#pragma once

#include <windows.h>

// FMFt@Cwb_ (20 bytes)
typedef struct tag_FMFHeader
{
	DWORD	dwIdentifier;	// t@Cʎq 'FMF_'
	DWORD	dwSize;			// wb_f[^TCY
	DWORD	dwWidth;		// }bv̉
	DWORD	dwHeight;		// }bv̍
	BYTE	byChipWidth;	// }bv`bv1̕(pixel)
	BYTE	byChipHeight;	// }bv`bvP̍(pixel)
	BYTE	byLayerCount;	// C[̐
	BYTE	byBitCount;		// Cf[^̃rbgJEg
}FMFHEADER;

class CFmfMap
{
public:
	// \z/
	CFmfMap(void);
	~CFmfMap();

	// }bvJăf[^ǂݍ
	BOOL Open(const char *szFilePath);

	// }bvJĂ邩
	BOOL IsOpen() const;

	// }bvJ
	void Close(void);
		
	// w背C[̐擪AhX𓾂
	void* GetLayerAddr(BYTE byLayerIndex) const;
	
	// CԍƍWw肵Ēڃf[^Ⴄ
	int GetValue(BYTE byLayerIndex, DWORD dwX, DWORD dwY) const;

	// CԍƍWw肵ăf[^Zbg
	void SetValue(BYTE byLayerIndex, DWORD dwX, DWORD dwY, int nValue);

	// wb_̏𓾂
	DWORD GetMapWidth(void) const;
	DWORD GetMapHeight(void) const;
	BYTE GetChipWidth(void) const;
	BYTE GetChipHeight(void) const;
	BYTE GetLayerCount(void) const;
	BYTE GetLayerBitCount(void) const;
protected:
	// FMFt@Cwb_\
	FMFHEADER	m_fmfHeader;
	// C[f[^ւ̃|C^
	BYTE* 		m_pLayerAddr;
};

/*	Tv
int Hoge(const char *filePath)
{
	CFmfMap map;
	BYTE* pLayer;

	if (!map.Open(filePath))
	{
		// }bvJȂB
		return 1;
	}

	// 0ԁiԉ̃C[j̃AhXႤ
	pLayer = (BYTE*)map.GetLayerAddr(0)
	if (lpLayer == NULL)
	{
		map.Close();
		return 1;
	}

	DWORD width = map.GetMapWidth();
	DWORD height = map.GetMapHeight();
	DWORD cWidth = map.GetChipWidth();
	DWORD cHeight = map.GetChipHeight();
	int srcX, srcY;
	BYTE index;	
	
	// }bv̕`
	for (DWORD y = 0; y < height; y++)
	{
		for (DWORD x = 0; x < width ; x++)
		{
			index = *(pLayer + y * width + x);
			// ܂
			index = map.GetValue(0, x, y);
			
			// indexɂ̓}bvW(x, y)̃}bvf[^Ă̂
			// p[c摜(srcHDC)valueɌ`Zoĕ`揈sB
			// }bv8bit̏ꍇp[c̃ACg16A16bitȂ256B
			srcX = (index % 16) * cWidth;
			srcY = (index / 16) * cHeight;
			BitBlt(	dstHDC, x * cWidth, y * cHeight, cWidth, cHeight,
					srcHDC, srcX, srcY, SRCCOPY);
		}
	}

	// W(15,10)̃f[^oꍇ
	value = *(pLayer + 10 * width + 15);
	
	// 
	map.Close();
	
	return 0;
}
*/

#endif